#include "classicmapcreator.h"
#include "classicnote.h"

// Replace with interface by dependency injection
#include "classicflyinganimationscenario.h"
#include "classicdyinganimationscenario.h"
//

ClassicMapCreator::ClassicMapCreator(const std::shared_ptr<ClassicGraphicsManager>& manager) :
    _graphics_manager(manager)
{}

Beatmap ClassicMapCreator::createBeatmap(const std::string& filepath) const
{
    (void) filepath;

    microsec starting_beat_offset = 362162;
    int amount_of_beats = 209;
    microsec interval = 1412162;
    microsec tempo_interval = interval / 2;
    microsec note_input_offset = 412162 / 2;
    //microsec note_input_offset_fast = 412162 / 6;
    microsec bpm_iterator = starting_beat_offset;
    microsec bpm_end = starting_beat_offset + (interval * amount_of_beats);

    std::vector<microsec> input_intervals = {note_input_offset / 3, note_input_offset / 3 * 2, note_input_offset};
    std::vector<ClassicNote*> notes;
    input_intervals.shrink_to_fit();

    bpm_iterator += tempo_interval;

    float x = 90.;

    int counter = 3;

    while (bpm_iterator < bpm_end)
    {
        ClassicNote *note = new ClassicNote(
        {
            {input_intervals, bpm_iterator},
            {input_intervals},
            false,
            ClassicNoteState::NONE,
            {
                ClassicNote::Element
                {
                    {x, 390.},
                    false,
                    sf::Keyboard::Unknown,
                    Type::UP,
                    {},
                    {sf::Keyboard::W, sf::Keyboard::Up},
                    {nullptr},
                    {}
                }
            }
        });

        note->elements[0].animations[ClassicNoteState::NONE] = nullptr;
        note->elements[0].animations[ClassicNoteState::FLYING] = std::make_shared<ClassicFlyingAnimationScenario>();
        note->elements[0].animations[ClassicNoteState::ACTIVE] = note->elements[0].animations[ClassicNoteState::FLYING];
        note->elements[0].animations[ClassicNoteState::DYING] = std::make_shared<ClassicDyingAnimationScenario>();
        note->elements[0].animations[ClassicNoteState::DEAD] = nullptr;

        if (counter == 0)
        {
            note->hold = true;
            note->elements[0].available_keys = {sf::Keyboard::D, sf::Keyboard::Right};
            note->elements[0].type = Type::RIGHT;
        }

        --counter;

        notes.emplace_back(note);

        bpm_iterator += tempo_interval;
        x += 70;

        if (x >= 1200)
            x = 90.;
    }

    return {std::move(notes), note_input_offset * 12};
}
