#pragma once

#include "gui/state.h"
#include "tools/music.h"
#include "tools/resourceholder.h"
#include <SFML/Graphics/RenderWindow.hpp>

class MenuBar;
class BPMCalculator;

class Editor : public GUIState
{
public:

    struct Callbacks
    {
        std::function<void(void)> onLeaveEditorState;
    };

    explicit Editor(sf::RenderWindow& game_window, Callbacks&& callbacks, std::unique_ptr<Music>&& music, const FontHolder& font_holder);
    virtual void input(const sf::Event& event) override;
    virtual void update() override;
    virtual void draw() const override;

    virtual void enter() override;
    virtual void leave() override;

private:
    std::shared_ptr<MenuBar> _menu_bar;
    sf::RenderWindow& _game_window;

    std::shared_ptr<Music> _music;
    std::shared_ptr<BPMCalculator> _bpm_calculator;
};

