#include "gamestate.h"
#include "widgets/button.h"
#include "widgets/group.h"

#include "game/game.h"

GameState::GameState(sf::RenderWindow& game_window, const std::shared_ptr<Game>& game,
                     Callbacks&& callbacks) :
    _game(game),
    _game_window(game_window),
    _onLeaveGameCallback(callbacks.onLeaveGame)
{}

void GameState::input(const sf::Event& event)
{
    _game->input({0, event});
}

void GameState::update()
{
    _game->update();
}

void GameState::draw() const
{
    _game->draw();
}

void GameState::enter()
{
    _game->run();
}

void GameState::leave()
{
    _onLeaveGameCallback();
}
