#pragma once

#include "gui/state.h"
#include <SFML/Graphics/RenderWindow.hpp>

class Group;
class Game;

class GameState : public GUIState
{
public:

    struct Callbacks
    {
        std::function<void(void)> onLeaveGame;
    };


    explicit GameState(sf::RenderWindow& game_window,
                       const std::shared_ptr<Game>& game,
                       Callbacks&& callbacks);

    virtual void input(const sf::Event& event) override;
    virtual void update() override;
    virtual void draw() const override;

    virtual void enter() override;
    virtual void leave() override;

private:
    std::shared_ptr<Game> _game;
    sf::RenderWindow& _game_window;

    std::function<void(void)> _onEnterGameCallback;
    std::function<void(void)> _onLeaveGameCallback;
};

