#pragma once

#include "widget.h"
#include "menudrop.h"
#include "button.h"

#include <SFML/Graphics/RectangleShape.hpp>

class MenuBar : public Widget
{
public:
    explicit MenuBar(const std::shared_ptr<sf::Font>& font);

    virtual void input(const sf::Event& event) override;
    virtual void update() override;
    virtual void draw(sf::RenderTarget& target, sf::RenderStates states) const override;
    virtual void setRect(const sf::FloatRect& rect) override;
    virtual void setPosition(const sf::Vector2f& position) override;
    virtual bool isUnderMouse(int mouse_x, int mouse_y) const override;
    virtual void setVisibility(bool is_visible = true) override;

    void addSubMenu(std::string name, const std::shared_ptr<MenuDrop>& submenu);

private:
    std::shared_ptr<sf::Font> _font;
    sf::RectangleShape _bar_rect;
    std::size_t _amount_buttons;
    std::size_t _button_width;

    std::vector<std::shared_ptr<MenuDrop>> _submenus;
};
