#pragma once

#include "widget.h"
#include "pushbutton.h"
#include "cascademenubutton.h"
#include <SFML/Graphics/RectangleShape.hpp>

class MenuDrop : public Widget
{
public:
    explicit MenuDrop();

    virtual void input(const sf::Event& event) override;
    virtual void update() override;
    virtual void draw(sf::RenderTarget& target, sf::RenderStates states) const override;
    virtual void setRect(const sf::FloatRect& rect) override;
    virtual void setPosition(const sf::Vector2f& position) override;
    virtual bool isUnderMouse(int mouse_x, int mouse_y) const override;
    virtual void setVisibility(bool is_visible = true) override;

    void addPushButton(const std::shared_ptr<PushButton>& button);
    void addCascadeButton(const std::shared_ptr<CascadeMenuButton>& button);
    void addSeparator();

    void lock();
    void unlock();
    bool isLocked() const;

private:
    sf::RectangleShape _content_rect;
    bool _is_locked;

    std::size_t _button_height;
    std::size_t _button_index;

    std::vector<std::shared_ptr<MenuDrop>> _submenus;

    void add(const std::shared_ptr<Widget>& widget);
    bool hasActiveSubmenus() const;
};
